# Abstract
## Feature
### WeexCore
* Unified C++ log system of WeexCore.

### Android
* Upgrade targetsdk & compilesdk to 28
* Change Android package name from `com.taobao.weex` to `org.apache.weex`, ref [link](https://github.com/apache/incubator-weex/tree/master/android#build-types)
* Switch to BSD-Licensed [android-jsc](https://www.npmjs.com/package/jsc-android) as the default JavaScript Interpreter.

## Main Bugfix
# Detail Commit
* Update publish_release_candiate. d17bd0b10
* Remove .iml fiie e317671d6
* Update setting.gradle ac460b44e
* Update changelog 25e95f176
* Remove possible-notices-for-bin-dist 03235ce64
* [Android] Fix task order problem. (#2964) 0688a2419
* Add ASF license header to a bunch of files. (#2963) ce518bcdb
* [Android] Download JSC header files from remote during compiling (#2960) 685ec8acd
*  [Android] Remove shared library from binary of Weex (#2940) 739e07f3e
* Update scripts for apache release. 01adab8c1
* Add clearBFCs method and clear BFCs after self-layout of scroller node. 43f5edb6f
* [iOS] Fix slider crash on iOS9 7bb97fc60
* [iOS] Rename the backgroundColor property name. (#2951) 51c8d1258
* Fix eagle refresh instance Npe be912769d
* [iOS Use property to access 'backgroundColor'. (#2948) c778ff372
* [iOS] Remove useless switch. 97840a1f2
* [iOS] Remove useless switch. 3919fdbc4
* [iOS] Use lock to add mutex for _backgroundColor property usage. ce42fd610
* Revert "[iOS] Fix problem that _backgroundColor causing multithread crashing. (#2934)" e2ca90622
* Revert "[iOS] Fix the problem that background color should use [UIColor clearColor] instance when transparent. (#2942)" 3a8a7ffd8
* Revert "[iOS] Fix the problem that background color should use [UIColor clearColor] instance when transparent. (#2943)" 65e7acbe1
* [iOS] Protect endless iteration when setting index for slider view. cb7fe0323
* [iOS] Fix the problem that background color should use [UIColor clearColor] instance when transparent. (#2943) f2786a184
* [Android] add log for reload and fm init count b107915a3
* Update Travis 41351337c
* [Android] open enableAlarmSignal config 555ae8226
* [iOS] Fix the problem that background color should use [UIColor clearColor] instance when transparent. (#2942) 2c169da9b
* [Android] public method readStreamToString 55c1da46d
* Double11 fix2 (#2937) 69cfe53cd
* Fix CTFont changed under xcode11 build. (#2936) 344bb3f7a
* [Android] Rename packageName from `com.taobao.weex` to `org.apache.weex` (#2885) 7548ba621
*  [Android] Remove android test files as they are not runnable anyway and could lead confusion by the package name `com.taobao.weex (#2932) 601fcb261
* [Android] Split whitescreen code which reboot count>50 c8ab8f17b
* [iOS] Fix problem that _backgroundColor causing multithread crashing. (#2934) 87454ac33
* [iOS] Protect for invalid JSON object on iOS13 which will crash. 146169900
*  [Android] Avoid ArrayIndexOutOfBounds in RenderPage::MoveRenderObject (#2919) ec1ec238c
* [iOS] Remove 'Too many timers' report. (#2930) e8f323a00
*  [Android] Change JNI string in cpp/h file (#2928) 724d8878f
* [Android] Split build.gradle file into 5 files. (#2927) c54282302
* [Android] Add the ability of renaming package by -PapachePackageName=false (#2925) 9b07a12a4
*  [Android] Make Travis quiet. (#2926) 334ca88a6
* Bugfx/revert 2783 2883 (#2924) bc32968cf
* Revert "[Android]support "wx" in animation and wxtext (#2783)" b9c003a74
* Revert "[Android] Change default value to from NAN to 0 (#2883)" fe41a75da
* [iOS] add WXTabbarComponentCreatedCallback on instance e2dc1bb05
* [Android] close alarm_signal for release test (#2916) 3c6eb357c
* [Android] close alarm_signal for release test 2bef3bb41
* [iOS] Add last page info. (#2918) 549915468
* [Android] Avoid multiple error. (#2915) 4ce90b04b
* [Android] Revert WeexFrame (#2912) 3337bc82a
* [Travis] Fail travis if Android build fails (#2911) 5de6b6b28
* [Android] Build playground in Travis (#2910) 3279829e8
* [Android] add mode check (#2908) d24e5af1e
* [iOS] close MultiJSThread and add some log 08345d7c6
* [Android] dump ipc mmap page flag when white screen (#2903) c06d42e97
* bugfix ios 8.11.1 crash by destroy instance on multithreading e788595a0
* bugfix ios 8.11.1 multithreading crash by eagle destroy instance 263521e60
* [Android] Fix Crash in NotifyLayout (#2902) 5e8d9ac93
* [Android] fix white screen cause deadlock (#2901) 89a1097d2
*  [Android] add For Webview get OnActivity Result (#2899) 8a6c6fa02
* Initialize weex using portrait screen size. (#2898) 393969296
* [Android] Fix ClassCastException in WXComponent.updateProperties() (#2897) b94e83074
* Optimize iOS logs. (#2896) 4ce557b6d
* Fix bug that when view is not loaded or not attached to a window, the CA animation completion callback is immediately called. d951f9729
* [iOS] Break retain cycle when set function of JSContext cbb8af1a4
* [iOS] Release property name after set property a32c5782c
* [Android] Change default value to from NAN to 0 (#2883) 6daad9ee3
* [iOS] public the dictionary of recordStatsMap and recordStageMap (#2882) a554cd6c9
* [Android] Fix crash in receiver. (#2840) 7543ea757
* fix crash if mmap failed (#2880) 440ae80ad
* [Android] Remove duplicate receiver in manifest and remove final from class definition. (#2879) cbfb57bee
* Fix nullable annotation. (#2878) 72b0bdb9b
* Change some error level log to debug level (#2877) 23821f9f0
* [iOS] modify eagle error code group from js to native d06b96e3d
* Update ErrorCode (#2875) e580b36a5
* Fix potential crash of animation. 8ce131838
* [Android]move wrap.sh to android/sdk (#2868) e50844f75
* [Android] Add support for screen rotation (#2867) 655200236
* [Android]support "wx" in animation and wxtext (#2783) 1f54d46bd
* [Android] Support for ASAN (#2862) 59f1ee0cb
* [iOS]fix crash when call getlayouttime c24fd9466
* C++文件改为" " 导入方式 9e5fc1fc3
* 删除test中调用未公开方法 6a45fd5cb
* [iOS] add  a callback on wxsdkinstance dd6a39bd3
* Feature/try fix top native crash fd problem (#2854) af7c957b2
* avoid log npe (#2856) 8722cf338
* optional调整 648e0f5b3
* 修改WeexSDKTests，测试通过 4912fd125
* Public Header 添加WXStreamModule.h， 构建成功 42a7d6f22
* 初步optional适配 3c3dd9ec0
* Fix npe (#2842) f64a86608
* [Android] Do not sent ipc message when son process crashed (#2838) 5bce92c58
* add new TimeCalculator for defaultConstructor (#2836) 5e969866c
* [iOS] fix the offset error of textarea a7d6d3a0d
* [Android] Fix C++ Crash in WeexCore::NotifyLayout. (#2831) f3c3c17a7
* [Android] Fix Android Crash in PostTaskToMsgLoop (#2830) 16e476e24
* Revert "[Android] Android] restart weexCoreThread when reload JSEngine because thread maybe in lock state and can't execute reload action (block) (#2824)" (#2829) 36fdc330c
* [iOS] add flag of grey bundle (#2828) 84c3bb9e6
* [Android] Fix Android JNI Crash (#2827) 7e54ac5c1
* [Android] record ipc exception history and weexCoreThread stackTrace when white screen or js process died/reload (#2826) a994ce97e
* [Android] Android] restart weexCoreThread when reload JSEngine because thread maybe in lock state and can't execute reload action (block) (#2824) c72e6b5a8
* [iOS] output render timeline on iOS 86bc455a5
* Do Not abort when Ipc receive end type (#2814) ff2c0792e
* layout引擎Frame计算修改为向上取整 4b6903533
* [iOS] Protect nil argument for convertContainerToImmutable. c09b54b81
* Avoid wx_component nil 11afad896
* 添加eventPenetrationEnabled属性，属性为true时，当响应者为自身时将事件穿透传递（子视图正常响应） 5f586c3d7
* setUserInteractionEnabled b8ac8fa6e
* 修改属性为BOOL 71268b5d3
* fix travis ci 6f9c3f093
* [Android] fix list op bug in Multithreading (#2798) 185524704
* fix remaining oclint warning 731780044
* fix remaining oclint warning b02199ee4
* [Travis] Change git clone depth to 1(false) (#2796) 3980f26a4
* use lastest weex-playground ceef4534c
* update .travis.yml and reset playground 0cd3e4cd7
* remove codeFormat task in Travis CI da83464f2
* reset Gemfile.lock 7e0165546
* update changes for code review b21ef7e60
* resolve conflict 6e2a51eef
* resolve conflict 02443726d
* [Travis] Add Lint in TravisCI and Update iOS TravisCI (#2731) 3bfb61912
* [Android] record jsbundle execute time (#2793) 0135e3c5d
* [Android] Upgrade to android 28 (#2791) d469e47b5
* [iOS] fix logimplement crash 7c48b0d69
* [Android] white_screen check ignore unvisible view (alpha unvisible) (#2788) 586271769
* [iOS] support jsTaskQueue thread safe bc252dc49
* [Core] Fix header file path (#2787) b333c987e
* View支持userInteraction属性 7cda54cf1
* reset weex-playground be622ac35
* update c958456a0
* Do not reboot jsc manually if jsc is crashed (#2782) 6da71f05e
* add //!OCLintin those code line which need skip oclint 331636681
* [Android] Fix problems in Android Lint (#2781) 24a30b31e
* [Android] Add some annotation to suppress android lint. (#2779) 9ea64b90a
* reset unrelated file 8fe222e09
* reset unrelated file 3e65784b2
* reset unrelated file 5f7d3d5b3
* fix oclint warning 18b13b088
* [Android] Fix problems in Android Lint (#2777) 756eb7874
* Fix some lint problems (#2776) 529a56fee
* [iOS] add fake performance detail data for server test (#2775) cf31bc0bb
* [iOS] Convert to immutable instance. Make code stronger. (#2772) dc63c56bb
* Feature/new log branch (#2768) 10ddeced1
* [iOS] Protect animation argument missing which cause crash on iOS. (#2771) 7b51a1dbe
* [Android] Avoid duplicated call of setViewPort (#2764) b2a455a43
* [iOS] fix multi jsthread error e4c48f585
* reset java file 2f2d3a7be
* add comment to danger-output.js fddd73ac5
* format androidlint output and add a java file for test 8ef6a1026
* format androidlint output c535016fa
*  [Android] record performance detail cost (#2769) 76bfd6b5b
* reset java file fb5fbb6cc
* test android lint 98dc05539
* [iOS] fix interaction time bad case : keyboard show and input (addView) 8ce7d11ac
* [Core] support Richtext component on eagle (#2766) 0b12b28d4
* remove android lint plugin 31004d03a
* finish 0400639b2
* update xml directory cd13248f9
* read sdk/build/reports/lint-results.xml and update b6aa447eb
* read sdk/build/reports/lint-results.xml 18bd2097e
* remove android lint plugin test2 d0b48c081
* remove android lint plugin 25838240c
* only keep android lint to test 9 3e661369e
* only keep android lint to test 8 efa2145d1
* only keep android lint to test 7 1e5f1a6c0
* only keep android lint to test 6 392c8360d
* only keep android lint to test 5 5a22656a1
* only keep android lint to test 084777cec
* only keep android lint to test 90c3a8792
* only keep android lint to test 5d4c33416
* add lintOptions:xmlReport true in android/sdk/build.gradle 6e3b2e7e6
* remove modify for Gemfile.lock 8dfff58c8
* fix android lint plugin 677c3fe01
* add -quiet to solve log too log and increase git init in android e3e9a0a1a
* try to fix ios build error f07e90f1d
* brew update node cba1a26c2
* remove osx_image: xcode7.2 and add cd android 049f48142
* add java file 4c159fd30
* update  to grep 65647dd2f
* change to yarn because npm package error and install android lint plugin 748fa4411
* reset package.json and package-lock.json 09bf60ea8
* reset yarn to npm run danger -- 51a05c015
* Support "wx" in  Transform.translate ca289f46e
* update node to 12.6 e563bbf94
* update npm package 1d9d5a0c1
* update f3cf951e5
* [Android] fix interaction badcase (#2762) 2b9d773ce
* update danger run to danger ci daed95cca
* update npm from 7.6 to 8.0 3083794a9
* update npm to yarn e91e1e076
* remove -i 19436369b
* update danger from 0.8 to 9.0 And --danger-id d25582d1a
* Update ReadMe and contributing (#2760) 31f708903
* update bc0579386
* reset .travis.yml and Gemfile 0df574e78
* output oclint message 11dd0e506
* test DEBUG="*" e50cfb188
* Fix heron event (#2747) a0aae4ff7
* update  ClassLoaderAdapter.java f79edc184
* Update ClassLoaderAdapter.java fef51ddec
* update ClassLoaderAdapter.java 8ef0ecc30
* Update ClassLoaderAdapter.java 3531b256e
* Update ClassLoaderAdapter.java d6917085c
* Update .travis.yml b66e8b8ee
* test dangerfile static check 1dd7270c3
* fix playground build fail d9ee7e6b6
* merge efc46147c
* [Danger] Add some static check rules in dangerfile (#2676) 0898c8f57
* [Android] Fix show-indicators doesn't work. (#2746) 7e7bec08b
* [Doc] Update contributing.md (#2745) 1d81470ca
* [Android] Remove duplicated file which is the same as weex_core/Source/base/android/jniprebuild/jniheader/WXBridge_jni.h (#2744) d91e735a6
* Update .travis.yml ce436aa46
* ios uitest fail and exit 97ae5152f
* [Android] Fix setViewPort invalid (#2738) 6631c9def
* update3 e199c3f7e
* update3 d9431109d
* update3 5b49f3577
* update3 ce77b0cb7
* update2 266bcb6fa
* update 9bb8a1061
* upload ios/sdk/.gitignore a4777c483
* Delete 1.sh b7d474efa
* test-5 d4d3efd3d
* test-4 76f0e2f88
* test-3 c678b2cfc
* test -2 86de4c3f9
* test 78ffbd503
* test c0e261ff8
* update android and ios e8321bc86
* update android and ios 160b8aad8
* update 8a36f04c6
* update 59ac99180
* update 310c32e52
* .travis.yml 6dbff5cac
* .travis.yml 006c765b4
* update .travis.yml for oclint 7a5f6b049
* merge bfc7a40e3
* Move uikit type report to proper position so that apmInstance will not ignore it. (#2741) e93bd9141
* test ios travis 615f84dda
* test 7cba71bf8
* update .travis.yml acc85c199
* adjust job order 193124d87
* test code format and asan2 2aff44d3a
* test code format and asan 931cbc07d
* test code format and asan 7b8def1db
* test code format and asan 69a406b55
* add asan cedf4fb41
* add asan 950a8cbdb
* [Android] Change log. (#2739) 9768a92da
* test for dangerfile ruby 4b30d748e
* test for dangerfile ruby b6cb33bd9
* test for dangerfile ruby 2d964506f
* test for dangerfile ruby b189e3d45
* test for dangerfile ruby a52a63505
* test for dangerfile ruby d0407b95d
* [Android] close runtimeApi mode for performance issue. and will reopen when issue fixed (#2736) 222cdce62
* test 9907c9111
* test d439e9981
* test 18a95737d
* test d54f801f9
* test b6711dce5
* Update .travis.yml dbcaa922b
* add new line in android/sdk/src/main/java/com/taobao/weex/adapter/ClassLoaderAdapter.java 45dbeafe6
* add new line in android/sdk/src/main/java/com/taobao/weex/adapter/ClassLoaderAdapter.java 0cbc129b1
* add new line in android/sdk/src/main/java/com/taobao/weex/adapter/ClassLoaderAdapter.java eed9cc454
* add new line in android/sdk/src/main/java/com/taobao/weex/adapter/ClassLoaderAdapter.java 82c5bb601
* add new line in android/sdk/src/main/java/com/taobao/weex/adapter/ClassLoaderAdapter.java dc625cfad
* test android code format ca1573b8d
* Fix text line-height property error 272a39360
* delete 0adc403ba
* upload ios/sdk/.gitignore 7804e01c5
* Delete 1.sh 345a85eae
* test-5 cb0687b5b
* test-5 798e86771
* test-4 3825f0039
* test-3 45632bfd1
* test -2 c19263cbe
* test 70382ff8c
* test d226c555b
* update android and ios fce5c37ff
* update android and ios c2ff7d008
* update da83adfe7
* update 5aa966d6b
* update 1c99e5911
* [Android] fix timeout args get and fix js microtask Timing (#2729) 72c51f076
* [Android] Update component data report (#2728) f15b5f66c
* .travis.yml 2a2e99870
* .travis.yml 175b74717
* update .travis.yml for oclint bbf94462b
* update .travis.yml for oclint d6d127f94
* Fix Chinese text italic property f8c3d2926
* Fix Chinese text italic property 5bcbe6d17
* [Android] add jsthread watch log && more log (#2722) 1ee8c7432
* [Android] add bigCell detail msg for analyzer on debug performance mode (#2719) 124543208
* [Android] report error when reboot count > CRASHREINIT (#2720) 49f0cf9f9
* [Android] Update for libweexjsb path (#2712) 57bd65c64
*  [Android] Move initialization of PlatformBridge to JNI_Load(#2715) 1e40e9ced
* Pass immutable arguments to JS to avoid JSC crash. (#2714) c371398f9
* [iOS] Update TravisCI  for  iOS. (#2713) 34811191e
* Update build.gradle (#2711) d2d2b614b
* iOS playground seperation (#2709) 5f01b57c2
* [Android] Update build.gradle and TravisCI (#2703) 05555b362
* [Android] Fix build error (#2710) b0ba7bc2e
* add .muppignoresubmodule (#2708) 6259ffcbe
* [Android] No need to reboot js engine if render by eagle (#2696) 961ac8348
* [Android] Throw link error if load so failed in debugApp (#2705) cea65ecd8
* [jsfm] Also enable the promise polyfill on Android (#2704) eae533c5a
* merge 7e93ae36d
* [Android] Separate playground (#2688) 05c675869
* [Android] Fix createFinish problem (#2701) 23c8f3e47
* Improve Podspec (#2693) 1afd84854
* Change ThreadLocker's location cab9ab7e0
* [Android] Change license rule in build.gradle (#2690) 674f95fc2
* Remove unused files of iOS. (#2687) dc3dfff28
* [iOS] fix compile error 862c0bf0e
* Merge 0.26 (#2685) a7df76c89
* Update Weex Version e9078b2ac
* Update release script. bab3d2884
* remove high-ndk-api-level (#2677) 0c284c982
* Fix crash of accessing apm stage data not in component thread. (#2678) 56444e0c1
* [jsruntime] add runtime code (a/b) and build success (#2669) f6f1127b7
* fix crash 2533381d1
* [Android] FIX NP (#2670) 74e98b027
* Add render time origin fix. Fix issue that interaction time calculated by heron is much different with platform. (#2666) 354c15de6
* [Android] bugfix of  the scrollstart and scrollend  event mismatching (#2638) c928c5c76
* Do not check multi thread flag when create instance (#2667) 7e274f2dc
* [Android]remove gpu overflow reporter (#2664) b668f3005
* [Android] Fix potential NPE (#2662) 159ccdc2f
* [Android] Fix potential NPE (#2663) ce01b5b95
* [Android]fix slider border radius invalid problem (#2658) 32fac7675
* Update TravisCI (#2634) fdec2eeae
* [Android] Supply message for version check tool failure. (#2649) d8bbe7453
* strtof -> strtod (#2648) c2b366447
* [Android] fix ConcurrentModificationException for analyzerList && print error log when exception (#2647) 45da9ef46
* [Android] Add Log for subProcess (#2644) 4695a70f0
* fix corner 4e888775c
* Remove iOS9 deprecated interface usage. (#2643) 3768c8fa5
* Upgrade iOS deployment target to 9.0 (#2641) 29a600a09
* Merge heron into master (#2636) 67bad4f44
* [Android] solve components exceed gpu limit problem (#2603) 48a7cb7cf
* Update TravisCI for android NDK (#2319) d23e29c05
* [iOS] Fix dynamic library build issue. (#2631) c2dcc1abd
* [Android] fix whiteScreen viewTree record && run state history record (#2629) 925a922d6
* [iOS] add execute jsbundle time point (#2628) 19602910a
